Index: branches/HeuristicLab.Problems.GrammaticalOptimization/Main/Program.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/Main/Program.cs	(revision 11793)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/Main/Program.cs	(revision 11795)
@@ -1,3 +1,3 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Data;
@@ -160,17 +160,17 @@
       // TODO: in contextual MCTS store a bandit info for each node in the _graph_ and also update all bandit infos of all parents
       // TODO: exhaustive search with priority list
-      // TODO: warum funktioniert die alte Implementierung von GaussianThompson besser für SantaFe als neue? Siehe Vergleich: alte vs. neue implementierung GaussianThompsonSampling
+      // TODO: warum funktioniert die alte Implementierung von GaussianThompson besser fÃŒr SantaFe als neue? Siehe Vergleich: alte vs. neue implementierung GaussianThompsonSampling
       // TODO: why does GaussianThompsonSampling work so well with MCTS for the artificial ant problem?
-      // TODO: wie kann ich sampler noch vergleichen bzw. was kann man messen um die qualität des samplers abzuschätzen (bis auf qualität und iterationen bis zur besten lösung) => ziel schnellere iterationen zu gutem ergebnis
+      // TODO: wie kann ich sampler noch vergleichen bzw. was kann man messen um die qualitÃ€t des samplers abzuschÃ€tzen (bis auf qualitÃ€t und iterationen bis zur besten lÃ¶sung) => ziel schnellere iterationen zu gutem ergebnis
       // TODO: research thompson sampling for max bandit?
-      // TODO: ausführlicher test von strategien für numCorrectPhrases-armed max bandit
+      // TODO: ausfÃŒhrlicher test von strategien fÃŒr numCorrectPhrases-armed max bandit
       // TODO: verify TA implementation using example from the original paper      
       // TODO: separate policy from MCTS tree data structure to allow sharing of information over disconnected parts of the tree (semantic equivalence)
       // TODO: implement thompson sampling for gaussian mixture models
-      // TODO: implement inspection for MCTS (eventuell interactive command line für statistiken aus dem baum anzeigen)
+      // TODO: implement inspection for MCTS (eventuell interactive command line fÃŒr statistiken aus dem baum anzeigen)
       // TODO: implement ACO-style bandit policy
       // TODO: gleichzeitige modellierung von transformierter zielvariable (y, 1/y, log(y), exp(y), sqrt(y), ...)
-      // TODO: vergleich bei complete-randomly möglichst kurze sätze generieren vs. einfach zufällig alternativen wählen
-      // TODO: reward discounting (für veränderliche reward distributions über zeit). speziellen unit-test dafür erstellen
+      // TODO: vergleich bei complete-randomly mÃ¶glichst kurze sÃ€tze generieren vs. einfach zufÃ€llig alternativen wÃ€hlen
+      // TODO: reward discounting (fÃŒr verÃ€nderliche reward distributions ÃŒber zeit). speziellen unit-test dafÃŒr erstellen
       // TODO: constant optimization 
 
@@ -191,9 +191,20 @@
       // var problem = new FindPhrasesProblem(random, 15, numPhrases, phraseLen, numOptimalPhrases: numPhrases, numDecoyPhrases: 0, correctReward: 1.0, decoyReward: 0.0, phrasesAsSets: true);
 
-      //var problem = new SymbolicRegressionPoly10Problem();   // good results e.g. 10 randomtries and EpsGreedyPolicy(0.2, (aInfo)=>aInfo.MaxReward)
-      // Ant
-      // good results e.g. with       var alg = new MctsSampler(problem, 17, random, 1, (rand, numActions) => new ThresholdAscentPolicy(numActions, 500, 0.01));
-      // GaussianModelWithUnknownVariance (and Q= 0.99-quantil) also works well for Ant
-
+      // good results for symb-reg
+      // prev results: e.g. 10 randomtries and EpsGreedyPolicy(0.2, (aInfo)=>aInfo.MaxReward)
+      // 2015 01 19: grid test with canonical states: 
+      // - EpsGreedyPolicy(0.20,max)
+      // - GenericThompsonSamplingPolicy("")
+      // - UCTPolicy(0.10) (5 of 5 runs, 35000 iters avg.)
+      
+      // good results for artificial ant:
+      // prev results: 
+      // - var alg = new MctsSampler(problem, 17, random, 1, (rand, numActions) => new ThresholdAscentPolicy(numActions, 500, 0.01));
+      // - GaussianModelWithUnknownVariance (and Q= 0.99-quantil) also works well for Ant
+      // 2015 01 19: grid test with canonical states (non-canonical slightly worse)
+      // - Threshold Ascent (best 100, 0.01; all variants relatively good
+
+      //var problem = new SymbolicRegressionPoly10Problem();   
+      
       var problem = new SantaFeAntProblem();
       //var problem = new SymbolicRegressionProblem("Tower"); 