Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/HeuristicLab.NRefactory-5.5.0/HeuristicLab.NRefactory-5.5.0.csproj
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/HeuristicLab.NRefactory-5.5.0/HeuristicLab.NRefactory-5.5.0.csproj	(revision 11809)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/HeuristicLab.NRefactory-5.5.0/HeuristicLab.NRefactory-5.5.0.csproj	(revision 11810)
@@ -116,4 +116,8 @@
       <Name>ICSharpCode.NRefactory.CSharp-5.5.0</Name>
     </ProjectReference>
+    <ProjectReference Include="..\NRefactory.Xml-5.5.0\ICSharpCode.NRefactory.Xml-5.5.0.csproj">
+      <Project>{c5ae5d30-ae8c-4017-b741-99e084281000}</Project>
+      <Name>ICSharpCode.NRefactory.Xml-5.5.0</Name>
+    </ProjectReference>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/HeuristicLab.NRefactory-5.5.0/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/HeuristicLab.NRefactory-5.5.0/Plugin.cs.frame	(revision 11809)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/HeuristicLab.NRefactory-5.5.0/Plugin.cs.frame	(revision 11810)
@@ -28,4 +28,5 @@
   [PluginFile("ICSharpCode.NRefactory.Cecil.dll", PluginFileType.Assembly)]
   [PluginFile("ICSharpCode.NRefactory.CSharp.dll", PluginFileType.Assembly)]
+  [PluginFile("ICSharpCode.NRefactory.Xml.dll", PluginFileType.Assembly)]
   [PluginFile("ICSharpCode.NRefactory License-5.5.0.txt", PluginFileType.License)]
   public class HeuristicLabNRefactoryPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/NRefactory.Xml-5.5.0/ICSharpCode.NRefactory License-5.5.0.txt
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/NRefactory.Xml-5.5.0/ICSharpCode.NRefactory License-5.5.0.txt	(revision 11810)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/NRefactory.Xml-5.5.0/ICSharpCode.NRefactory License-5.5.0.txt	(revision 11810)
@@ -0,0 +1,17 @@
+Copyright (c) 2010-2014 AlphaSierraPapa, Xamarin
+
+Permission is hereby granted, free of charge, to any person obtaining a copy of this
+software and associated documentation files (the "Software"), to deal in the Software
+without restriction, including without limitation the rights to use, copy, modify, merge,
+publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
+to whom the Software is furnished to do so, subject to the following conditions:
+
+The above copyright notice and this permission notice shall be included in all copies or
+substantial portions of the Software.
+
+THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
+INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
+PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
+FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
+OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+DEALINGS IN THE SOFTWARE.
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/NRefactory.Xml-5.5.0/ICSharpCode.NRefactory.Xml-5.5.0.csproj
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/NRefactory.Xml-5.5.0/ICSharpCode.NRefactory.Xml-5.5.0.csproj	(revision 11809)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.NRefactory/5.5.0/NRefactory.Xml-5.5.0/ICSharpCode.NRefactory.Xml-5.5.0.csproj	(revision 11810)
@@ -125,4 +125,7 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <Content Include="ICSharpCode.NRefactory License-5.5.0.txt" />
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 