Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/HeuristicLab.CodeEditor-3.4.csproj
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/HeuristicLab.CodeEditor-3.4.csproj	(revision 11815)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/HeuristicLab.CodeEditor-3.4.csproj	(revision 11816)
@@ -156,5 +156,5 @@
     <Compile Include="LanguageFeatures\CodeCompletion\CSharp\CSharpCodeCompletionContext.cs" />
     <Compile Include="LanguageFeatures\CodeCompletion\CSharp\CSharpCodeCompletionDataFactory.cs" />
-    <Compile Include="LanguageFeatures\CodeCompletion\CSharp\CSharpCodeCompletionHelpers.cs" />
+    <Compile Include="LanguageFeatures\Helpers\CSharpParsingHelpers.cs" />
     <Compile Include="LanguageFeatures\CodeCompletion\CSharp\CompletionData\EntityCompletionData.cs" />
     <Compile Include="LanguageFeatures\CodeCompletion\CSharp\CompletionData\ImportCompletionData.cs" />
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionContext.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionContext.cs	(revision 11815)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionContext.cs	(revision 11816)
@@ -46,5 +46,5 @@
       this.offset = offset;
 
-      var unresolvedFile = CSharpCodeCompletionHelpers.CreateCSharpUnresolvedFile(this.document);
+      var unresolvedFile = CSharpParsingHelpers.CreateCSharpUnresolvedFile(this.document);
       this.projectContent = projectContent.AddOrUpdateFiles(unresolvedFile);
 
Index: unk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionHelpers.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionHelpers.cs	(revision 11815)
+++ 	(revision )
@@ -1,35 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using ICSharpCode.NRefactory.CSharp;
-using ICSharpCode.NRefactory.CSharp.TypeSystem;
-using ICSharpCode.NRefactory.Editor;
-
-namespace HeuristicLab.CodeEditor {
-  internal class CSharpCodeCompletionHelpers {
-    public static CSharpUnresolvedFile CreateCSharpUnresolvedFile(IDocument document) {
-      var parser = new CSharpParser();
-      var syntaxTree = parser.Parse(document, document.FileName);
-      syntaxTree.Freeze();
-      return syntaxTree.ToTypeSystem();
-    }
-  }
-}
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionStrategy.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionStrategy.cs	(revision 11815)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeCompletion/CSharp/CSharpCodeCompletionStrategy.cs	(revision 11816)
@@ -56,5 +56,5 @@
         completionContext.ProjectContent,
         completionContext.TypeResolveContextAtCaret
-      ) { EolMarker = Environment.NewLine };
+        );
 
       char completionChar = completionContext.Document.GetCharAt(completionContext.Offset - 1);
@@ -119,5 +119,5 @@
       );
 
-      var unresolvedFile = CSharpCodeCompletionHelpers.CreateCSharpUnresolvedFile(document);
+      var unresolvedFile = CSharpParsingHelpers.CreateCSharpUnresolvedFile(document);
       projectContent = projectContent.AddOrUpdateFiles(unresolvedFile);
     }
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingContext.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingContext.cs	(revision 11815)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/CodeFolding/CSharp/CSharpCodeFoldingContext.cs	(revision 11816)
@@ -25,15 +25,13 @@
 namespace HeuristicLab.CodeEditor {
   internal class CSharpCodeFoldingContext {
-    public readonly IDocument Document;
-    public readonly SyntaxTree SyntaxTree;
+    private readonly IDocument document;
+    public IDocument Document { get { return document; } }
+
+    private readonly SyntaxTree syntaxTree;
+    public SyntaxTree SyntaxTree { get { return syntaxTree; } }
 
     public CSharpCodeFoldingContext(IDocument document) {
-      Document = new ReadOnlyDocument(document, document.FileName);
-
-      var parser = new CSharpParser();
-      var syntaxTree = parser.Parse(document, document.FileName);
-      syntaxTree.Freeze();
-
-      SyntaxTree = syntaxTree;
+      this.document = new ReadOnlyDocument(document, document.FileName);
+      syntaxTree = CSharpParsingHelpers.CreateSyntaxTree(this.document);
     }
   }
Index: /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Helpers/CSharpParsingHelpers.cs
===================================================================
--- /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Helpers/CSharpParsingHelpers.cs	(revision 11816)
+++ /trunk/sources/HeuristicLab.CodeEditor/3.4/LanguageFeatures/Helpers/CSharpParsingHelpers.cs	(revision 11816)
@@ -0,0 +1,41 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using ICSharpCode.NRefactory.CSharp;
+using ICSharpCode.NRefactory.CSharp.TypeSystem;
+using ICSharpCode.NRefactory.Editor;
+
+namespace HeuristicLab.CodeEditor {
+  internal class CSharpParsingHelpers {
+    public static SyntaxTree CreateSyntaxTree(IDocument document) {
+      var parser = new CSharpParser();
+      var syntaxTree = parser.Parse(document, document.FileName);
+      return syntaxTree;
+    }
+
+    public static CSharpUnresolvedFile CreateCSharpUnresolvedFile(IDocument document) {
+      var syntaxTree = CreateSyntaxTree(document);
+      syntaxTree.Freeze();
+      var unresolvedFile = syntaxTree.ToTypeSystem();
+      return unresolvedFile;
+    }
+  }
+}